"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_CHECKBOX_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return CheckboxWidgetComponent; }),
    multi: true
};
var CheckboxWidgetChange = (function () {
    function CheckboxWidgetChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return CheckboxWidgetChange;
}());
exports.CheckboxWidgetChange = CheckboxWidgetChange;
var CheckboxWidgetComponent = (function () {
    function CheckboxWidgetComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = false;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = false;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    CheckboxWidgetComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    CheckboxWidgetComponent.prototype.handleValueChange = function (value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    CheckboxWidgetComponent.prototype.emitChangeEvent = function () {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new CheckboxWidgetChange(this, this.value));
    };
    CheckboxWidgetComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    CheckboxWidgetComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    CheckboxWidgetComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    CheckboxWidgetComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return CheckboxWidgetComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], CheckboxWidgetComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], CheckboxWidgetComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], CheckboxWidgetComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], CheckboxWidgetComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CheckboxWidgetComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], CheckboxWidgetComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], CheckboxWidgetComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], CheckboxWidgetComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], CheckboxWidgetComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], CheckboxWidgetComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], CheckboxWidgetComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CheckboxWidgetComponent.prototype, "change", void 0);
CheckboxWidgetComponent = __decorate([
    core_1.Component({
        selector: 'tanj-checkbox-widget',
        template: "<!-- -->\n  <div flex class=\"tanj-input-template tanj-mode-edit\"\n       [ngClass]=\"{'tanj-disabled': disabled}\"\n       layout=\"row\"\n       layout-align=\"center center\">\n    <span *ngIf=\"!hideLabel && labelPosition == 'before'\"\n          class=\"tanj-label tanj-checkbox-widget-label\">{{label}}</span>\n    <div flex class=\"tanj-widget-input\" layout=\"column\" layout-align=\"start center\">\n      <div *ngIf=\"!onlyLabel\"\n           class=\"tanj-widget-input\"\n           layout=\"column\"\n           layout-align=\"start\">\n        <md-checkbox flex\n                     [disabled]=\"disabled\"\n                     [(ngModel)]=\"value\"\n                     (change)=\"handleValueChange(value)\">\n        </md-checkbox>\n      </div>\n      <div *ngIf=\"!hideLabel && labelPosition == 'below'\" class=\"tanj-label tanj-below\">{{label}}</div>\n    </div>\n    <span *ngIf=\"!hideLabel && labelPosition == 'after'\" class=\"tanj-label tanj-checkbox-widget-label\">{{label}}</span>\n  </div>\n                 ",
        providers: [exports.TANJ_CHECKBOX_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], CheckboxWidgetComponent);
exports.CheckboxWidgetComponent = CheckboxWidgetComponent;

//# sourceMappingURL=checkbox-widget.component.js.map
