"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DateTimeWidgetConfigureComponent; }),
    multi: true
};
var DateTimeWidgetConfigureChange = (function () {
    function DateTimeWidgetConfigureChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return DateTimeWidgetConfigureChange;
}());
exports.DateTimeWidgetConfigureChange = DateTimeWidgetConfigureChange;
var DateTimeWidgetConfigureComponent = (function () {
    function DateTimeWidgetConfigureComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValue = Date.now();
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.defaultToNowChange = new core_1.EventEmitter(false);
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    DateTimeWidgetConfigureComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    DateTimeWidgetConfigureComponent.prototype.ngOnChanges = function (changes) {
    };
    DateTimeWidgetConfigureComponent.prototype.emitChangeEvent = function (value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DateTimeWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    DateTimeWidgetConfigureComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    DateTimeWidgetConfigureComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    DateTimeWidgetConfigureComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    DateTimeWidgetConfigureComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return DateTimeWidgetConfigureComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], DateTimeWidgetConfigureComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], DateTimeWidgetConfigureComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], DateTimeWidgetConfigureComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DateTimeWidgetConfigureComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetConfigureComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DateTimeWidgetConfigureComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DateTimeWidgetConfigureComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DateTimeWidgetConfigureComponent.prototype, "label", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetConfigureComponent.prototype, "labelChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DateTimeWidgetConfigureComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetConfigureComponent.prototype, "defaultValueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DateTimeWidgetConfigureComponent.prototype, "defaultToNow", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetConfigureComponent.prototype, "defaultToNowChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetConfigureComponent.prototype, "change", void 0);
DateTimeWidgetConfigureComponent = __decorate([
    core_1.Component({
        selector: 'tanj-date-time-configure',
        template: "<!-- -->\n  <div class=\"tanj-input-template tanj-mode-configure\" flex layout=\"column\" layout-align=\"start\">\n    <md-input-container dividerColor=\"accent\">\n      <input mdInput class=\"tanj-input\" type=\"text\" maxlength=\"50\" placeholder=\"Enter a label for this input\"\n             (change)=\"labelChange.emit(label)\"\n             [(ngModel)]=\"label\"/>\n    </md-input-container>\n    <ng-container *ngIf=\"label\">\n      <md-slide-toggle class=\"tanj-input\" [labelPosition]=\"'before'\" [(ngModel)]=\"defaultToNow\">Default to current time?\n      </md-slide-toggle>\n      <tanj-date-time-widget *ngIf=\"!defaultToNow\" [(value)]=\"defaultValue\"\n                            (valueChange)=\"value = defaultValue; emitChangeEvent(true, false)\"\n                            [defaultValue]=\"defaultValue\"\n                            label=\"Default Value\"></tanj-date-time-widget>\n    </ng-container>\n  </div>\n                 ",
        providers: [exports.TANJ_DATE_TIME_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], DateTimeWidgetConfigureComponent);
exports.DateTimeWidgetConfigureComponent = DateTimeWidgetConfigureComponent;

//# sourceMappingURL=date-time-widget-configure.component.js.map
