"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
var moment = require("moment");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_DATE_TIME_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return DateTimeWidgetComponent; }), multi: true
};
var DateTimeWidgetChange = (function () {
    function DateTimeWidgetChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return DateTimeWidgetChange;
}());
exports.DateTimeWidgetChange = DateTimeWidgetChange;
var DateTimeWidgetComponent = (function () {
    function DateTimeWidgetComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = Date.now();
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultToNow = false;
        this.defaultValue = 0;
        this.maxLength = 100;
        this.minLength = 0;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.onTouched = function () {
        };
        this.controlValueAccessorChangeFn = function (value) {
        };
    }
    DateTimeWidgetComponent.prototype.ngOnInit = function () {
        this.value = this.defaultToNow ? Date.now() : this.defaultValue;
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    Object.defineProperty(DateTimeWidgetComponent.prototype, "dateInputValue", {
        get: function () {
            return moment(this.value).format('YYYY-MM-DDTHH:mm:ss');
        },
        set: function (dateString) {
            this.value = moment(dateString).valueOf();
        },
        enumerable: true,
        configurable: true
    });
    DateTimeWidgetComponent.prototype.ngOnChanges = function (changes) {
        if (changes.defaultToNow && !this.value) {
            this.value = this.defaultToNow ? Date.now() : this.defaultValue;
        }
    };
    DateTimeWidgetComponent.prototype.handleValueChange = function (value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    DateTimeWidgetComponent.prototype.emitChangeEvent = function () {
        var change = new DateTimeWidgetChange(this, this.value);
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(change);
    };
    DateTimeWidgetComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    DateTimeWidgetComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    DateTimeWidgetComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    DateTimeWidgetComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return DateTimeWidgetComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], DateTimeWidgetComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], DateTimeWidgetComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], DateTimeWidgetComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DateTimeWidgetComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DateTimeWidgetComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DateTimeWidgetComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DateTimeWidgetComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DateTimeWidgetComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DateTimeWidgetComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DateTimeWidgetComponent.prototype, "defaultToNow", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DateTimeWidgetComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DateTimeWidgetComponent.prototype, "maxLength", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DateTimeWidgetComponent.prototype, "minLength", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DateTimeWidgetComponent.prototype, "change", void 0);
DateTimeWidgetComponent = __decorate([
    core_1.Component({
        selector: 'tanj-date-time-widget', template: "<!-- -->\n  <div flex class=\"tanj-input-template tanj-mode-edit\"\n       [ngClass]=\"{'tanj-disabled': disabled}\"\n       layout=\"row\"\n       layout-align=\"start center\">\n    <span *ngIf=\"!hideLabel && labelPosition == 'before'\" class=\"tanj-label tanj-before\">{{label}}</span>\n    <div flex class=\"tanj-widget-input\" layout=\"column\" layout-align=\"center start\">\n      <div flex *ngIf=\"!onlyLabel\" class=\"tanj-widget-input\" layout=\"row\" layout-align=\"start\">\n        <md-input-container flex\n                            class=\"tanj-date-time-input-field tanj-widget-input\"\n                            dividerColor=\"accent\"\n                            layout=\"row\"\n                            layout-align=\"start\">\n          <input flex\n                 mdInput\n                 class=\"tanj-input\"\n                 type=\"datetime-local\"\n                 minlength=\"{{minLength}}\"\n                 maxlength=\"{{maxLength}}\"\n                 [disabled]=\"disabled\"\n                 (change)=\"valueChange.emit(value)\"\n                 [(ngModel)]=\"dateInputValue\"/>\n        </md-input-container>\n      </div>\n      <span *ngIf=\"!hideLabel && labelPosition == 'below'\" class=\"tanj-label tanj-below\">{{label}}</span>\n    </div>\n    <span *ngIf=\"!hideLabel && labelPosition == 'after'\" class=\"tanj-label tanj-after\">{{label}}</span>\n  </div>\n            ", providers: [exports.TANJ_DATE_TIME_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], DateTimeWidgetComponent);
exports.DateTimeWidgetComponent = DateTimeWidgetComponent;

//# sourceMappingURL=date-time-widget.component.js.map
