"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
var moment = require("moment");
var duration_picker_state_1 = require("./duration-picker-state");
/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DurationPickerWidgetConfigureComponent; }),
    multi: true
};
var DurationPickerWidgetConfigureChange = (function () {
    function DurationPickerWidgetConfigureChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return DurationPickerWidgetConfigureChange;
}());
exports.DurationPickerWidgetConfigureChange = DurationPickerWidgetConfigureChange;
var DurationPickerWidgetConfigureComponent = (function () {
    function DurationPickerWidgetConfigureComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValue = 0;
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.maxChange = new core_1.EventEmitter(false);
        this.showDays = false;
        this.showDaysChange = new core_1.EventEmitter(false);
        this.showHours = false;
        this.showHoursChange = new core_1.EventEmitter(false);
        this.showMinutes = false;
        this.showMinutesChange = new core_1.EventEmitter(false);
        this.showSeconds = false;
        this.showSecondsChange = new core_1.EventEmitter(false);
        this.showMilliseconds = false;
        this.showMillisecondsChange = new core_1.EventEmitter(false);
        /* end Configuration Fields */
        this.state = new duration_picker_state_1.DurationPickerState();
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    DurationPickerWidgetConfigureComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    DurationPickerWidgetConfigureComponent.prototype.ngOnChanges = function (changes) {
        if (changes.value) {
            this.state.setDuration(moment.duration(this.value));
        }
        this.updateFields();
    };
    DurationPickerWidgetConfigureComponent.prototype.updateFields = function () {
        if (this.showDays) {
            this.state.select(core_2.TimeUnits.day);
        }
        if (this.showHours) {
            this.state.select(core_2.TimeUnits.h);
        }
        if (this.showMinutes) {
            this.state.select(core_2.TimeUnits.min);
        }
        if (this.showSeconds) {
            this.state.select(core_2.TimeUnits.s);
        }
        if (this.showMilliseconds) {
            this.state.select(core_2.TimeUnits.ms);
        }
    };
    DurationPickerWidgetConfigureComponent.prototype.emitChangeEvent = function () {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DurationPickerWidgetConfigureChange(this, this.value));
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    DurationPickerWidgetConfigureComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    DurationPickerWidgetConfigureComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    DurationPickerWidgetConfigureComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    DurationPickerWidgetConfigureComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return DurationPickerWidgetConfigureComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], DurationPickerWidgetConfigureComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], DurationPickerWidgetConfigureComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], DurationPickerWidgetConfigureComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DurationPickerWidgetConfigureComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DurationPickerWidgetConfigureComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetConfigureComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DurationPickerWidgetConfigureComponent.prototype, "label", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "labelChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DurationPickerWidgetConfigureComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "defaultValueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DurationPickerWidgetConfigureComponent.prototype, "max", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "maxChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetConfigureComponent.prototype, "showDays", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "showDaysChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetConfigureComponent.prototype, "showHours", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "showHoursChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetConfigureComponent.prototype, "showMinutes", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "showMinutesChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetConfigureComponent.prototype, "showSeconds", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "showSecondsChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetConfigureComponent.prototype, "showMilliseconds", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "showMillisecondsChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetConfigureComponent.prototype, "change", void 0);
DurationPickerWidgetConfigureComponent = __decorate([
    core_1.Component({
        selector: 'tanj-duration-picker-widget-configure',
        template: "<!--  -->\n  <div class=\"tanj-input-template tanj-mode-configure\" flex layout=\"column\" layout-align=\"start\">\n    <md-input-container dividerColor=\"accent\">\n      <input mdInput\n             class=\"tanj-input\"\n             type=\"text\"\n             maxlength=\"50\"\n             placeholder=\"Enter a label for this input\"\n             (change)=\"labelChange.emit(label)\"\n             [(ngModel)]=\"label\"/>\n    </md-input-container>\n\n    <ng-container *ngIf=\"label\">\n      <fieldset flex layout=\"row\" layout-align=\"start\">\n        <legend>For:</legend>\n        <div flex class=\"tanj-choose-duration-fields-container\" layout=\"column\" layout-align=\"start\">\n          <md-checkbox *ngFor=\"let field of state.fields\"\n                       layout=\"row\" layout-align=\"start\"\n                       [disabled]=\"!field.canToggleSelection()\"\n                       [labelPosition]=\"'before'\"\n                       [checked]=\"field.selected\"\n                       (change)=\"field.selected = $event.checked\">\n            {{field.unit.fullLabel}}\n          </md-checkbox>\n        </div>\n      </fieldset>\n\n      <tanj-duration-picker-widget\n        [(value)]=\"defaultValue\"\n        (valueChange)=\"value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)\"\n        [defaultValue]=\"defaultValue\"\n        [showDays]=\"showDays\"\n        [showHours]=\"showHours\"\n        [showMinutes]=\"showMinutes\"\n        [showSeconds]=\"showSeconds\"\n        [showMilliseconds]=\"showMilliseconds\"\n        [max]=\"max\"\n        label=\"Default Value\"\n        [labelPosition]=\"'before'\">\n      </tanj-duration-picker-widget>\n    </ng-container>\n\n  </div>\n                 ",
        providers: [exports.TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], DurationPickerWidgetConfigureComponent);
exports.DurationPickerWidgetConfigureComponent = DurationPickerWidgetConfigureComponent;

//# sourceMappingURL=duration-picker-widget-configure.component.js.map
