"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var material_1 = require("@angular/material");
var core_2 = require("@tangential/core");
var moment = require("moment");
var duration_picker_dialog_1 = require("./duration-picker-dialog");
var duration_picker_state_1 = require("./duration-picker-state");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DurationPickerWidgetComponent; }),
    multi: true
};
var DurationPickerWidgetChange = (function () {
    function DurationPickerWidgetChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return DurationPickerWidgetChange;
}());
exports.DurationPickerWidgetChange = DurationPickerWidgetChange;
var DurationPickerWidgetComponent = (function () {
    function DurationPickerWidgetComponent(changeDetectorRef, dialog) {
        this.changeDetectorRef = changeDetectorRef;
        this.dialog = dialog;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.showDays = false;
        this.showHours = false;
        this.showMinutes = false;
        this.showSeconds = false;
        this.showMilliseconds = false;
        this.change = new core_1.EventEmitter(false);
        this.state = new duration_picker_state_1.DurationPickerState();
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    DurationPickerWidgetComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    DurationPickerWidgetComponent.prototype.ngOnChanges = function (changes) {
        if (changes.value) {
            this.state.setDuration(moment.duration(this.value));
        }
        this.updateFields();
    };
    DurationPickerWidgetComponent.prototype.updateFields = function () {
        if (this.showDays) {
            this.state.select(core_2.TimeUnits.day);
        }
        if (this.showHours) {
            this.state.select(core_2.TimeUnits.h);
        }
        if (this.showMinutes) {
            this.state.select(core_2.TimeUnits.min);
        }
        if (this.showSeconds) {
            this.state.select(core_2.TimeUnits.s);
        }
        if (this.showMilliseconds) {
            this.state.select(core_2.TimeUnits.ms);
        }
    };
    DurationPickerWidgetComponent.prototype.showEditDialog = function () {
        var _this = this;
        var dialogRef = this.dialog.open(duration_picker_dialog_1.DurationPickerDialog, {
            disableClose: true,
            data: { state: this.state }
        });
        dialogRef.afterClosed().subscribe(function (result) {
            if (result.success) {
                _this.value = result.millis;
                _this.changeDetectorRef.detectChanges();
                _this.emitChangeEvent();
            }
        });
    };
    DurationPickerWidgetComponent.prototype.emitChangeEvent = function () {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DurationPickerWidgetChange(this, this.value));
        this.valueChange.emit(this.value);
        console.log('DurationPickerWidgetComponent', 'emitChangeEvent');
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    DurationPickerWidgetComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    DurationPickerWidgetComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    DurationPickerWidgetComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    DurationPickerWidgetComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return DurationPickerWidgetComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], DurationPickerWidgetComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], DurationPickerWidgetComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], DurationPickerWidgetComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DurationPickerWidgetComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DurationPickerWidgetComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DurationPickerWidgetComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DurationPickerWidgetComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DurationPickerWidgetComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "showDays", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "showHours", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "showMinutes", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "showSeconds", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DurationPickerWidgetComponent.prototype, "showMilliseconds", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], DurationPickerWidgetComponent.prototype, "change", void 0);
DurationPickerWidgetComponent = __decorate([
    core_1.Component({
        selector: 'tanj-duration-picker-widget',
        template: "<!-- -->\n  <div flex\n       class=\"tanj-input-template tanj-mode-edit\"\n       [ngClass]=\"{'tanj-disabled': disabled}\"\n       layout=\"row\"\n       layout-align=\"start center\"\n       (click)=\"showEditDialog()\">\n      <span *ngIf=\"!hideLabel && labelPosition == 'before'\"\n            class=\"tanj-label tanj-icon-rating-widget-label\">{{label}}</span>\n    <div flex class=\"tanj-widget-input\" layout=\"column\" layout-align=\"start center\">\n      <div *ngIf=\"!onlyLabel\"\n           class=\"tanj-widget-input\"\n           layout=\"row\"\n           layout-align=\"start\">\n\n        <ng-container *ngFor=\"let field of state.fields\">\n          <span *ngIf=\"field.selected\">{{field.value | number:'2.0-0'}}<span \n            *ngIf=\"field.next?.selected\">{{field.separator || ':'}}</span></span>\n        </ng-container>\n\n      </div>\n      <span *ngIf=\"!hideLabel && labelPosition == 'below'\" class=\"tanj-label tanj-below\">{{label}}</span>\n    </div>\n    <span *ngIf=\"!hideLabel && labelPosition == 'after'\" class=\"tanj-label tanj-after tanj-icon-rating-widget-label\">{{label}}</span>\n  </div>\n\n                 ",
        providers: [exports.TANJ_DURATION_PICKER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef, material_1.MdDialog])
], DurationPickerWidgetComponent);
exports.DurationPickerWidgetComponent = DurationPickerWidgetComponent;

//# sourceMappingURL=duration-picker-widget.component.js.map
