"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return IconRatingWidgetConfigureComponent; }),
    multi: true
};
var IconRatingWidgetConfigureChange = (function () {
    function IconRatingWidgetConfigureChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return IconRatingWidgetConfigureChange;
}());
exports.IconRatingWidgetConfigureChange = IconRatingWidgetConfigureChange;
var IconRatingWidgetConfigureComponent = (function () {
    function IconRatingWidgetConfigureComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.maxChange = new core_1.EventEmitter(false);
        this.iconFontChange = new core_1.EventEmitter(false);
        this.offIconNamesChange = new core_1.EventEmitter(false);
        this.onIconNamesChange = new core_1.EventEmitter(false);
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    IconRatingWidgetConfigureComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    IconRatingWidgetConfigureComponent.prototype.emitChangeEvent = function () {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new IconRatingWidgetConfigureChange(this, this.value));
    };
    IconRatingWidgetConfigureComponent.prototype.swipeRight = function (event) {
    };
    IconRatingWidgetConfigureComponent.prototype.swipeLeft = function (event) {
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    IconRatingWidgetConfigureComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    IconRatingWidgetConfigureComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    IconRatingWidgetConfigureComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    IconRatingWidgetConfigureComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return IconRatingWidgetConfigureComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], IconRatingWidgetConfigureComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], IconRatingWidgetConfigureComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], IconRatingWidgetConfigureComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], IconRatingWidgetConfigureComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], IconRatingWidgetConfigureComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], IconRatingWidgetConfigureComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], IconRatingWidgetConfigureComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], IconRatingWidgetConfigureComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], IconRatingWidgetConfigureComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], IconRatingWidgetConfigureComponent.prototype, "iconFont", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], IconRatingWidgetConfigureComponent.prototype, "offIconNames", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], IconRatingWidgetConfigureComponent.prototype, "onIconNames", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "labelChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "defaultValueChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "maxChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "iconFontChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "offIconNamesChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "onIconNamesChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetConfigureComponent.prototype, "change", void 0);
IconRatingWidgetConfigureComponent = __decorate([
    core_1.Component({
        selector: 'tanj-icon-rating-widget-configure',
        template: "<!-- -->\n  <div class=\"tanj-input-template tanj-mode-configure\" flex layout=\"column\" layout-align=\"start\">\n    <md-input-container dividerColor=\"accent\">\n      <input mdInput\n             class=\"tanj-input\"\n             type=\"text\"\n             maxlength=\"50\"\n             placeholder=\"Enter a label for this input\"\n             (change)=\"labelChange.emit(label)\"\n             [(ngModel)]=\"label\"/>\n    </md-input-container>\n    <ng-container *ngIf=\"label\">\n      <tanj-icon-rating-widget\n        [(value)]=\"defaultValue\"\n        (valueChange)=\"value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)\"\n        [defaultValue]=\"defaultValue\"\n        [max]=\"max\"\n        [iconFont]=\"iconFont\"\n        [offIconNames]=\"offIconNames\"\n        [onIconNames]=\"onIconNames\"\n        label=\"Default Value\"\n        [labelPosition]=\"'before'\">\n\n      </tanj-icon-rating-widget>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput\n               class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Max Rating\"\n               max=\"10\"\n               (change)=\"maxChange.emit(max)\"\n               [(ngModel)]=\"max\"/>\n      </md-input-container>\n    </ng-container>\n  </div>\n                 ",
        providers: [exports.TANJ_ICON_RATING_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], IconRatingWidgetConfigureComponent);
exports.IconRatingWidgetConfigureComponent = IconRatingWidgetConfigureComponent;

//# sourceMappingURL=icon-rating-widget-configure.component.js.map
