"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return IconRatingWidgetComponent; }),
    multi: true
};
var IconRatingWidgetChange = (function () {
    function IconRatingWidgetChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return IconRatingWidgetChange;
}());
exports.IconRatingWidgetChange = IconRatingWidgetChange;
var IconRatingWidgetComponent = (function () {
    function IconRatingWidgetComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    IconRatingWidgetComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    IconRatingWidgetComponent.prototype.ngOnChanges = function (changes) {
        if (this.max && this.iconFont && this.offIconNames && this.onIconNames) {
            this.icons = [];
            for (var i = 0; i < this.max; i++) {
                var icon = {
                    font: this.iconFont,
                    name: i <= this.value ? this.onIconNames[0] : this.offIconNames[0]
                    //                           star                 star_border
                };
                this.icons.push(icon);
            }
        }
    };
    IconRatingWidgetComponent.prototype.onIconClick = function (idx) {
        if (!this.disabled) {
            this.value = idx;
            this.valueChange.emit(this.value);
        }
    };
    IconRatingWidgetComponent.prototype.swipeRight = function (event) {
    };
    IconRatingWidgetComponent.prototype.swipeLeft = function (event) {
    };
    IconRatingWidgetComponent.prototype.emitChangeEvent = function () {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new IconRatingWidgetChange(this, this.value));
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    IconRatingWidgetComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    IconRatingWidgetComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    IconRatingWidgetComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    IconRatingWidgetComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return IconRatingWidgetComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], IconRatingWidgetComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], IconRatingWidgetComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], IconRatingWidgetComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], IconRatingWidgetComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], IconRatingWidgetComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], IconRatingWidgetComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], IconRatingWidgetComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], IconRatingWidgetComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], IconRatingWidgetComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], IconRatingWidgetComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], IconRatingWidgetComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], IconRatingWidgetComponent.prototype, "iconFont", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], IconRatingWidgetComponent.prototype, "offIconNames", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], IconRatingWidgetComponent.prototype, "onIconNames", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], IconRatingWidgetComponent.prototype, "change", void 0);
IconRatingWidgetComponent = __decorate([
    core_1.Component({
        selector: 'tanj-icon-rating-widget',
        template: "<!-- -->\n  <div flex\n       class=\"tanj-input-template tanj-mode-edit\"\n       [ngClass]=\"{'tanj-disabled': disabled}\"\n       layout=\"row\"\n       layout-align=\"center center\">\n    <span *ngIf=\"!hideLabel && labelPosition == 'before'\"\n          class=\"tanj-label tanj-icon-rating-widget-label\">{{label}}</span>\n    <div flex class=\"tanj-widget-input\" layout=\"column\" layout-align=\"start center\">\n      <div *ngIf=\"!onlyLabel\"\n           class=\"tanj-icon-rating-stars tanj-widget-input\"\n           layout=\"column\"\n           layout-align=\"start\"\n           (swipeRight)=\"swipeRight($event)\"\n           (swipeLeft)=\"swipeLeft($event)\">\n\n        <div flex class=\"tanj-icon-rating-icons-container\" layout=\"row\" layout-align=\"start\">\n          <tanj-icon *ngFor=\"let icon of icons; let idx = index\" [icon]=\"icon\" (click)=\"onIconClick(idx)\"></tanj-icon>\n        </div>\n\n      </div>\n      <span *ngIf=\"!hideLabel && labelPosition == 'below'\" class=\"tanj-label tanj-below\">{{label}}</span>\n    </div>\n    <span *ngIf=\"!hideLabel && labelPosition == 'after'\" class=\"tanj-label tanj-after tanj-icon-rating-widget-label\">{{label}}</span>\n  </div>\n                 ",
        providers: [exports.TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], IconRatingWidgetComponent);
exports.IconRatingWidgetComponent = IconRatingWidgetComponent;

//# sourceMappingURL=icon-rating-widget.component.js.map
