"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_NUMBER_SLIDER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return NumberSliderWidgetConfigureComponent; }),
    multi: true
};
var NumberSliderWidgetConfigureChange = (function () {
    function NumberSliderWidgetConfigureChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return NumberSliderWidgetConfigureChange;
}());
exports.NumberSliderWidgetConfigureChange = NumberSliderWidgetConfigureChange;
var NumberSliderWidgetConfigureComponent = (function () {
    function NumberSliderWidgetConfigureComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'below';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.maxChange = new core_1.EventEmitter(false);
        this.minChange = new core_1.EventEmitter(false);
        this.stepChange = new core_1.EventEmitter(false);
        this.decimalPlacesChange = new core_1.EventEmitter(false);
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    NumberSliderWidgetConfigureComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    NumberSliderWidgetConfigureComponent.prototype.ngOnChanges = function (changes) {
    };
    NumberSliderWidgetConfigureComponent.prototype.emitChangeEvent = function (value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberSliderWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    NumberSliderWidgetConfigureComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    NumberSliderWidgetConfigureComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    NumberSliderWidgetConfigureComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    NumberSliderWidgetConfigureComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return NumberSliderWidgetConfigureComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], NumberSliderWidgetConfigureComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], NumberSliderWidgetConfigureComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], NumberSliderWidgetConfigureComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetConfigureComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], NumberSliderWidgetConfigureComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSliderWidgetConfigureComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], NumberSliderWidgetConfigureComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetConfigureComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetConfigureComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetConfigureComponent.prototype, "min", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetConfigureComponent.prototype, "step", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetConfigureComponent.prototype, "decimalPlaces", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "labelChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "defaultValueChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "maxChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "minChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "stepChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "decimalPlacesChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetConfigureComponent.prototype, "change", void 0);
NumberSliderWidgetConfigureComponent = __decorate([
    core_1.Component({
        selector: 'tanj-number-slider-configure',
        template: "<!-- -->\n  <div class=\"tanj-input-template tanj-mode-configure\" flex layout=\"column\" layout-align=\"start\">\n    <md-input-container dividerColor=\"accent\">\n      <input mdInput class=\"tanj-input\" type=\"text\" maxlength=\"50\" placeholder=\"Enter a label for this input\"\n             (change)=\"labelChange.emit(label)\"\n             [(ngModel)]=\"label\"/>\n    </md-input-container>\n    <ng-container *ngIf=\"label\">\n      <tanj-number-slider-widget [(value)]=\"defaultValue\"\n                                (valueChange)=\"value = defaultValue; emitChangeEvent(true, false)\"\n                                [defaultValue]=\"defaultValue\"\n                                [max]=\"max\"\n                                [min]=\"min\"\n                                [step]=\"step\"\n                                [decimalPlaces]=\"decimalPlaces\"\n                                label=\"Default Value\"></tanj-number-slider-widget>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput\n               class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Min\"\n               (change)=\"minChange.emit(min)\"\n               [(ngModel)]=\"min\"/>\n      </md-input-container>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput\n               class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Max\"\n               (change)=\"maxChange.emit(max)\"\n               [(ngModel)]=\"max\"/>\n      </md-input-container>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput\n               class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Step\"\n               (change)=\"stepChange.emit(step)\"\n               [(ngModel)]=\"step\"/>\n      </md-input-container>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Decimal Places\"\n               (change)=\"decimalPlacesChange.emit(decimalPlaces)\"\n               [(ngModel)]=\"decimalPlaces\"/>\n      </md-input-container>\n    </ng-container>\n\n  </div>\n                 ",
        providers: [exports.TANJ_NUMBER_SLIDER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], NumberSliderWidgetConfigureComponent);
exports.NumberSliderWidgetConfigureComponent = NumberSliderWidgetConfigureComponent;

//# sourceMappingURL=number-slider-widget-configure.component.js.map
