"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: core_1.forwardRef(function () { return NumberSliderWidgetComponent; }), multi: true
};
var NumberSliderWidgetChange = (function () {
    function NumberSliderWidgetChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return NumberSliderWidgetChange;
}());
exports.NumberSliderWidgetChange = NumberSliderWidgetChange;
var NumberSliderWidgetComponent = (function () {
    function NumberSliderWidgetComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'below';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.vertical = false;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.onTouched = function () {
        };
        this.controlValueAccessorChangeFn = function (value) {
        };
    }
    NumberSliderWidgetComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    NumberSliderWidgetComponent.prototype.ngOnChanges = function (changes) {
    };
    NumberSliderWidgetComponent.prototype.handleValueChange = function (value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    NumberSliderWidgetComponent.prototype.emitChangeEvent = function () {
        var change = new NumberSliderWidgetChange(this, this.value);
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(change);
    };
    NumberSliderWidgetComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    NumberSliderWidgetComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    NumberSliderWidgetComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    NumberSliderWidgetComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return NumberSliderWidgetComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], NumberSliderWidgetComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], NumberSliderWidgetComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], NumberSliderWidgetComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], NumberSliderWidgetComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSliderWidgetComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSliderWidgetComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSliderWidgetComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], NumberSliderWidgetComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "min", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "step", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "decimalPlaces", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSliderWidgetComponent.prototype, "tickInterval", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSliderWidgetComponent.prototype, "vertical", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSliderWidgetComponent.prototype, "change", void 0);
NumberSliderWidgetComponent = __decorate([
    core_1.Component({
        selector: 'tanj-number-slider-widget', template: "<!-- -->\n  <div flex class=\"tanj-input-template tanj-mode-edit\"\n       [ngClass]=\"{'tanj-disabled': disabled}\"\n       layout=\"row\"\n       layout-align=\"center center\">\n    <span *ngIf=\"!hideLabel && labelPosition == 'before'\"\n          class=\"tanj-label tanj-before\">{{label}}</span>\n    <div flex class=\"tanj-widget-input-container\" layout=\"column\" layout-align=\"start center\">\n      <div flex *ngIf=\"!onlyLabel\" class=\"tanj-widget-input\" layout=\"row\" layout-align=\"start\">\n        <md-slider flex\n                   [disabled]=\"disabled\"\n                   [(ngModel)]=\"value\"\n                   (change)=\"valueChange.emit(value)\"\n                   [max]=\"max\"\n                   [min]=\"min\"\n                   [step]=\"step\"\n                   [thumb-label]=\"true\"\n                   [tick-interval]=\"tickInterval\"\n                   [vertical]=\"vertical\">\n        </md-slider>\n        <md-input-container flex=\"15\"\n                            class=\"tanj-number-slider-input-field tanj-widget-input\"\n                            dividerColor=\"accent\"\n                            layout=\"row\"\n                            layout-align=\"start\">\n          <input flex\n                 mdInput\n                 class=\"tanj-input\"\n                 type=\"number\"\n                 max=\"{{max}}\"\n                 [disabled]=\"disabled\"\n                 [step]=\"step\"\n                 (change)=\"valueChange.emit(value)\"\n                 [(ngModel)]=\"value\"/>\n        </md-input-container>\n      </div>\n      <span *ngIf=\"!hideLabel && labelPosition == 'below'\" class=\"tanj-label tanj-below\">{{label}}</span>\n    </div>\n    <span *ngIf=\"!hideLabel && labelPosition == 'after'\" class=\"tanj-label tanj-after\">{{label}}</span>\n  </div>\n            ", providers: [exports.TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], NumberSliderWidgetComponent);
exports.NumberSliderWidgetComponent = NumberSliderWidgetComponent;

//# sourceMappingURL=number-slider-widget.component.js.map
