"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_NUMBER_SPINNER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return NumberSpinnerWidgetComponent; }),
    multi: true
};
var NumberSpinnerWidgetChange = (function () {
    function NumberSpinnerWidgetChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return NumberSpinnerWidgetChange;
}());
exports.NumberSpinnerWidgetChange = NumberSpinnerWidgetChange;
var NumberSpinnerWidgetComponent = (function () {
    function NumberSpinnerWidgetComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 10;
        this.min = 0;
        this.step = 1;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.keyboardInputToggled = false;
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    NumberSpinnerWidgetComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    NumberSpinnerWidgetComponent.prototype.ngOnChanges = function (changes) {
    };
    NumberSpinnerWidgetComponent.prototype.handleValueChange = function (value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    };
    NumberSpinnerWidgetComponent.prototype.onPreviousValueRequest = function () {
        if (!this.disabled) {
            var v = this.previousValue();
            if (v !== null) {
                this.handleValueChange(v);
            }
        }
    };
    NumberSpinnerWidgetComponent.prototype.onNextValueRequest = function () {
        if (!this.disabled) {
            var v = this.nextValue();
            if (v !== null) {
                this.handleValueChange(v);
            }
        }
    };
    NumberSpinnerWidgetComponent.prototype.nextValue = function () {
        var v = this.value + this.step;
        if (v > this.max) {
            v = null;
        }
        return v;
    };
    NumberSpinnerWidgetComponent.prototype.previousValue = function () {
        var v = this.value - this.step;
        if (v < this.min) {
            v = null;
        }
        return v;
    };
    NumberSpinnerWidgetComponent.prototype.swipeUp = function (event) {
        this.onNextValueRequest();
    };
    NumberSpinnerWidgetComponent.prototype.swipeDown = function (event) {
        this.onPreviousValueRequest();
    };
    NumberSpinnerWidgetComponent.prototype.onKeyboardInputRequest = function (event) {
        this.keyboardInputToggled = this.disabled ? false : !this.keyboardInputToggled;
    };
    /**
     * Boilerplate / required for Angular
     */
    NumberSpinnerWidgetComponent.prototype.emitChangeEvent = function () {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new NumberSpinnerWidgetChange(this, this.value));
    };
    NumberSpinnerWidgetComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    NumberSpinnerWidgetComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    NumberSpinnerWidgetComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    NumberSpinnerWidgetComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return NumberSpinnerWidgetComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], NumberSpinnerWidgetComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], NumberSpinnerWidgetComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], NumberSpinnerWidgetComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSpinnerWidgetComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSpinnerWidgetComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], NumberSpinnerWidgetComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSpinnerWidgetComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSpinnerWidgetComponent.prototype, "hideLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], NumberSpinnerWidgetComponent.prototype, "onlyLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], NumberSpinnerWidgetComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSpinnerWidgetComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSpinnerWidgetComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSpinnerWidgetComponent.prototype, "min", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], NumberSpinnerWidgetComponent.prototype, "step", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], NumberSpinnerWidgetComponent.prototype, "change", void 0);
NumberSpinnerWidgetComponent = __decorate([
    core_1.Component({
        selector: 'tanj-number-spinner-widget',
        template: "<!-- -->\n  <div flex\n       class=\"tanj-input-template tanj-mode-edit\"\n       [ngClass]=\"{'tanj-disabled': disabled}\"\n       layout=\"row\" layout-align=\"center center\">\n    <span *ngIf=\"!hideLabel && labelPosition == 'before'\" class=\"tanj-label tanj-before  tanj-number-spinner-label\">{{label}}</span>\n    <div flex class=\"tanj-widget-input\" layout=\"column\" layout-align=\"start center\">\n      <div *ngIf=\"!onlyLabel\"\n           class=\"tanj-input-spinner-field\"\n           layout=\"column\"\n           layout-align=\"start\"\n           (swipeUp)=\"swipeUp($event)\"\n           (swipeDown)=\"swipeDown($event)\">\n        <tanj-icon align=\"center\"\n                   font=\"material-icons\"\n                   ligature=\"arrow_drop_up\"\n                   (click)=\"$event.stopPropagation(); $event.preventDefault(); onNextValueRequest()\"></tanj-icon>\n        <div class=\"tanj-spinner-value tanj-previous \">{{previousValue() | number:'1.0-0'}}</div>\n        <div *ngIf=\"!keyboardInputToggled\"\n             class=\"tanj-spinner-value tanj-current\"\n             (click)=\"onKeyboardInputRequest($event)\">{{value | number:'1.0-0'}}\n        </div>\n        <input *ngIf=\"keyboardInputToggled\"\n               class=\"tanj-spinner-value tanj-current tanj-spinner-keyboard-input-toggled tanj-raw-input tanj-number\"\n               type=\"number\"\n               min=\"{{min}}\"\n               max=\"{{max}}\"\n               step=\"{{step}}\"\n               [(ngModel)]=\"value\"\n               autofocus\n               (blur)=\"keyboardInputToggled = false\">\n        <div class=\"tanj-spinner-value tanj-next\">{{nextValue() | number:'1.0-0'}}</div>\n        <tanj-icon align=\"center\"\n                   font=\"material-icons\"\n                   ligature=\"arrow_drop_down\"\n                   (click)=\"$event.stopPropagation(); $event.preventDefault(); onPreviousValueRequest()\"></tanj-icon>\n      </div>\n      <span *ngIf=\"!hideLabel && labelPosition == 'below'\" class=\"tanj-label tanj-below  tanj-number-spinner-label\">{{label}}</span>\n    </div>\n    <span *ngIf=\"!hideLabel && labelPosition == 'after'\"\n          class=\"tanj-label tanj-after  tanj-number-spinner-label\">{{label}}</span>\n  </div>\n                 ",
        providers: [exports.TANJ_NUMBER_SPINNER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], NumberSpinnerWidgetComponent);
exports.NumberSpinnerWidgetComponent = NumberSpinnerWidgetComponent;

//# sourceMappingURL=number-spinner-widget.component.js.map
