import { ChangeDetectorRef, EventEmitter, OnChanges, OnInit, SimpleChange } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
export declare const TANJ_NUMBER_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR: any;
export declare class NumberWidgetConfigureChange {
    source: NumberWidgetConfigureComponent;
    value: number;
    constructor(source: NumberWidgetConfigureComponent, value: number);
}
export declare class NumberWidgetConfigureComponent implements OnInit, OnChanges, ControlValueAccessor {
    private changeDetectorRef;
    flex: string;
    flexLayout: string;
    flexLayoutAlign: string;
    value: number;
    valueChange: EventEmitter<number>;
    labelPosition: 'before' | 'after' | 'below';
    disabled: boolean;
    /**
     * Configuration Fields
     */
    label: string;
    defaultValue: number;
    max: number;
    min: number;
    step: number;
    decimalPlaces: number;
    labelChange: EventEmitter<string>;
    defaultValueChange: EventEmitter<number>;
    maxChange: EventEmitter<number>;
    minChange: EventEmitter<number>;
    stepChange: EventEmitter<number>;
    decimalPlacesChange: EventEmitter<number>;
    change: EventEmitter<any>;
    /**
     * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
     * @docs-private
     */
    onTouched: () => any;
    private controlValueAccessorChangeFn;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: {
        config: SimpleChange;
        ival: SimpleChange;
    }): void;
    emitChangeEvent(value: boolean, label: boolean): void;
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value: number): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled: boolean): void;
}
