import { ChangeDetectorRef, EventEmitter, OnChanges, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
export declare const TANJ_NUMBER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR: any;
export declare class NumberWidgetChange {
    source: NumberWidgetComponent;
    value: number;
    constructor(source: NumberWidgetComponent, value: number);
}
export declare class NumberWidgetComponent implements ControlValueAccessor, OnChanges, OnInit {
    private changeDetectorRef;
    flex: string;
    flexLayout: string;
    flexLayoutAlign: string;
    value: number;
    valueChange: EventEmitter<number>;
    labelPosition: 'before' | 'after' | 'below';
    disabled: boolean;
    hideLabel: boolean;
    onlyLabel: boolean;
    /**
     * Configuration Fields
     */
    label: string;
    defaultValue: number;
    max: number;
    min: number;
    step: number;
    decimalPlaces: number;
    tickInterval: number;
    vertical: boolean;
    change: EventEmitter<any>;
    onTouched: () => any;
    private controlValueAccessorChangeFn;
    constructor(changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnChanges(changes: any): void;
    handleValueChange(value: number): void;
    /**
     * Boilerplate / required for Angular
     *
     */
    private emitChangeEvent();
    writeValue(value: number): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled: boolean): void;
}
