"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@tangential/core");
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_TEXT_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return TextWidgetConfigureComponent; }),
    multi: true
};
var TextWidgetConfigureChange = (function () {
    function TextWidgetConfigureChange(source, value) {
        this.source = source;
        this.value = value;
    }
    return TextWidgetConfigureChange;
}());
exports.TextWidgetConfigureChange = TextWidgetConfigureChange;
var TextWidgetConfigureComponent = (function () {
    function TextWidgetConfigureComponent(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = '';
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.maxLengthChange = new core_1.EventEmitter(false);
        this.minLengthChange = new core_1.EventEmitter(false);
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = function () { };
        this.controlValueAccessorChangeFn = function (value) { };
    }
    TextWidgetConfigureComponent.prototype.ngOnInit = function () {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    };
    TextWidgetConfigureComponent.prototype.ngOnChanges = function (changes) {
    };
    TextWidgetConfigureComponent.prototype.emitChangeEvent = function (value, label) {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new TextWidgetConfigureChange(this, this.value));
        if (value) {
            this.valueChange.emit(this.value);
            this.defaultValueChange.emit(this.defaultValue);
        }
        if (label) {
            this.labelChange.emit(this.label);
        }
    };
    /**
     * Boilerplate / required for Angular
     *
     */
    TextWidgetConfigureComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    TextWidgetConfigureComponent.prototype.registerOnChange = function (fn) {
        this.controlValueAccessorChangeFn = fn;
    };
    TextWidgetConfigureComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    TextWidgetConfigureComponent.prototype.setDisabledState = function (isDisabled) {
        this.disabled = isDisabled;
    };
    return TextWidgetConfigureComponent;
}());
__decorate([
    core_1.HostBinding('attr.flex'),
    __metadata("design:type", Object)
], TextWidgetConfigureComponent.prototype, "flex", void 0);
__decorate([
    core_1.HostBinding('attr.layout'),
    __metadata("design:type", Object)
], TextWidgetConfigureComponent.prototype, "flexLayout", void 0);
__decorate([
    core_1.HostBinding('attr.layout-align'),
    __metadata("design:type", Object)
], TextWidgetConfigureComponent.prototype, "flexLayoutAlign", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TextWidgetConfigureComponent.prototype, "value", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TextWidgetConfigureComponent.prototype, "valueChange", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TextWidgetConfigureComponent.prototype, "labelPosition", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TextWidgetConfigureComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TextWidgetConfigureComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TextWidgetConfigureComponent.prototype, "defaultValue", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], TextWidgetConfigureComponent.prototype, "maxLength", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], TextWidgetConfigureComponent.prototype, "minLength", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TextWidgetConfigureComponent.prototype, "labelChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TextWidgetConfigureComponent.prototype, "defaultValueChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TextWidgetConfigureComponent.prototype, "maxLengthChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TextWidgetConfigureComponent.prototype, "minLengthChange", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TextWidgetConfigureComponent.prototype, "change", void 0);
TextWidgetConfigureComponent = __decorate([
    core_1.Component({
        selector: 'tanj-text-configure',
        template: "<!-- -->\n  <div class=\"tanj-input-template tanj-mode-configure\" flex layout=\"column\" layout-align=\"start\">\n    <md-input-container dividerColor=\"accent\">\n      <input mdInput class=\"tanj-input\" type=\"text\" maxlength=\"50\" placeholder=\"Enter a label for this input\"\n             (change)=\"labelChange.emit(label)\"\n             [(ngModel)]=\"label\"/>\n    </md-input-container>\n    <ng-container *ngIf=\"label\">\n      <tanj-text-widget [(value)]=\"defaultValue\"\n                       (valueChange)=\"value = defaultValue; emitChangeEvent(true, false)\"\n                       [defaultValue]=\"defaultValue\"\n                       [maxLength]=\"maxLength\"\n                       [minLength]=\"minLength\"\n                       label=\"Default Value\"></tanj-text-widget>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput\n               class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Min Length\"\n               (change)=\"minLengthChange.emit(minLength)\"\n               [(ngModel)]=\"minLength\"/>\n      </md-input-container>\n      <md-input-container dividerColor=\"accent\">\n        <input mdInput\n               class=\"tanj-input\"\n               type=\"number\"\n               placeholder=\"Max Length\"\n               (change)=\"maxLengthChange.emit(max)\"\n               [(ngModel)]=\"maxLength\"/>\n      </md-input-container>\n    </ng-container>\n\n  </div>\n                 ",
        providers: [exports.TANJ_TEXT_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
        encapsulation: core_1.ViewEncapsulation.None
    }),
    __metadata("design:paramtypes", [core_1.ChangeDetectorRef])
], TextWidgetConfigureComponent);
exports.TextWidgetConfigureComponent = TextWidgetConfigureComponent;

//# sourceMappingURL=text-widget-configure.component.js.map
